# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.BasicAuthentication do
  @moduledoc """
  The authentication parameters to provide to the specified resource or URL that requires a username and password. Currently, only Basic HTTP authentication (https://tools.ietf.org/html/rfc7617) is supported in Uptime checks.

  ## Attributes

  *   `password` (*type:* `String.t`, *default:* `nil`) - The password to use when authenticating with the HTTP server.
  *   `username` (*type:* `String.t`, *default:* `nil`) - The username to use when authenticating with the HTTP server.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :password => String.t() | nil,
          :username => String.t() | nil
        }

  field(:password)
  field(:username)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.BasicAuthentication do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.BasicAuthentication.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.BasicAuthentication do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
