# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.IstioCanonicalService do
  @moduledoc """
  Canonical service scoped to an Istio mesh. Anthos clusters running ASM >= 1.6.8 will have their services ingested as this type.

  ## Attributes

  *   `canonicalService` (*type:* `String.t`, *default:* `nil`) - The name of the canonical service underlying this service. Corresponds to the destination_canonical_service_name metric label in label in Istio metrics (https://cloud.google.com/monitoring/api/metrics_istio).
  *   `canonicalServiceNamespace` (*type:* `String.t`, *default:* `nil`) - The namespace of the canonical service underlying this service. Corresponds to the destination_canonical_service_namespace metric label in Istio metrics (https://cloud.google.com/monitoring/api/metrics_istio).
  *   `meshUid` (*type:* `String.t`, *default:* `nil`) - Identifier for the Istio mesh in which this canonical service is defined. Corresponds to the mesh_uid metric label in Istio metrics (https://cloud.google.com/monitoring/api/metrics_istio).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :canonicalService => String.t() | nil,
          :canonicalServiceNamespace => String.t() | nil,
          :meshUid => String.t() | nil
        }

  field(:canonicalService)
  field(:canonicalServiceNamespace)
  field(:meshUid)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.IstioCanonicalService do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.IstioCanonicalService.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.IstioCanonicalService do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
