# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.MetricRange do
  @moduledoc """
  A MetricRange is used when each window is good when the value x of a single TimeSeries satisfies range.min <= x <= range.max. The provided TimeSeries must have ValueType = INT64 or ValueType = DOUBLE and MetricKind = GAUGE.

  ## Attributes

  *   `range` (*type:* `GoogleApi.Monitoring.V3.Model.GoogleMonitoringV3Range.t`, *default:* `nil`) - Range of values considered "good." For a one-sided range, set one bound to an infinite value.
  *   `timeSeries` (*type:* `String.t`, *default:* `nil`) - A monitoring filter (https://cloud.google.com/monitoring/api/v3/filters) specifying the TimeSeries to use for evaluating window quality.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :range => GoogleApi.Monitoring.V3.Model.GoogleMonitoringV3Range.t() | nil,
          :timeSeries => String.t() | nil
        }

  field(:range, as: GoogleApi.Monitoring.V3.Model.GoogleMonitoringV3Range)
  field(:timeSeries)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.MetricRange do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.MetricRange.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.MetricRange do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
