# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.PointData do
  @moduledoc """
  A point's value columns and time interval. Each point has one or more point values corresponding to the entries in point_descriptors field in the TimeSeriesDescriptor associated with this object.

  ## Attributes

  *   `timeInterval` (*type:* `GoogleApi.Monitoring.V3.Model.TimeInterval.t`, *default:* `nil`) - The time interval associated with the point.
  *   `values` (*type:* `list(GoogleApi.Monitoring.V3.Model.TypedValue.t)`, *default:* `nil`) - The values that make up the point.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :timeInterval => GoogleApi.Monitoring.V3.Model.TimeInterval.t() | nil,
          :values => list(GoogleApi.Monitoring.V3.Model.TypedValue.t()) | nil
        }

  field(:timeInterval, as: GoogleApi.Monitoring.V3.Model.TimeInterval)
  field(:values, as: GoogleApi.Monitoring.V3.Model.TypedValue, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.PointData do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.PointData.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.PointData do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
