# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.QueryTimeSeriesResponse do
  @moduledoc """
  The QueryTimeSeries response.

  ## Attributes

  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - If there are more results than have been returned, then this field is set to a non-empty value. To see the additional results, use that value as page_token in the next call to this method.
  *   `partialErrors` (*type:* `list(GoogleApi.Monitoring.V3.Model.Status.t)`, *default:* `nil`) - Query execution errors that may have caused the time series data returned to be incomplete. The available data will be available in the response.
  *   `timeSeriesData` (*type:* `list(GoogleApi.Monitoring.V3.Model.TimeSeriesData.t)`, *default:* `nil`) - The time series data.
  *   `timeSeriesDescriptor` (*type:* `GoogleApi.Monitoring.V3.Model.TimeSeriesDescriptor.t`, *default:* `nil`) - The descriptor for the time series data.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :nextPageToken => String.t() | nil,
          :partialErrors => list(GoogleApi.Monitoring.V3.Model.Status.t()) | nil,
          :timeSeriesData => list(GoogleApi.Monitoring.V3.Model.TimeSeriesData.t()) | nil,
          :timeSeriesDescriptor => GoogleApi.Monitoring.V3.Model.TimeSeriesDescriptor.t() | nil
        }

  field(:nextPageToken)
  field(:partialErrors, as: GoogleApi.Monitoring.V3.Model.Status, type: :list)
  field(:timeSeriesData, as: GoogleApi.Monitoring.V3.Model.TimeSeriesData, type: :list)
  field(:timeSeriesDescriptor, as: GoogleApi.Monitoring.V3.Model.TimeSeriesDescriptor)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.QueryTimeSeriesResponse do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.QueryTimeSeriesResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.QueryTimeSeriesResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
