# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.Telemetry do
  @moduledoc """
  Configuration for how to query telemetry on a Service.

  ## Attributes

  *   `resourceName` (*type:* `String.t`, *default:* `nil`) - The full name of the resource that defines this service. Formatted as described in https://cloud.google.com/apis/design/resource_names.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :resourceName => String.t() | nil
        }

  field(:resourceName)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.Telemetry do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.Telemetry.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.Telemetry do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
