# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.TimeSeriesData do
  @moduledoc """
  Represents the values of a time series associated with a TimeSeriesDescriptor.

  ## Attributes

  *   `labelValues` (*type:* `list(GoogleApi.Monitoring.V3.Model.LabelValue.t)`, *default:* `nil`) - The values of the labels in the time series identifier, given in the same order as the label_descriptors field of the TimeSeriesDescriptor associated with this object. Each value must have a value of the type given in the corresponding entry of label_descriptors.
  *   `pointData` (*type:* `list(GoogleApi.Monitoring.V3.Model.PointData.t)`, *default:* `nil`) - The points in the time series.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :labelValues => list(GoogleApi.Monitoring.V3.Model.LabelValue.t()) | nil,
          :pointData => list(GoogleApi.Monitoring.V3.Model.PointData.t()) | nil
        }

  field(:labelValues, as: GoogleApi.Monitoring.V3.Model.LabelValue, type: :list)
  field(:pointData, as: GoogleApi.Monitoring.V3.Model.PointData, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.TimeSeriesData do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.TimeSeriesData.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.TimeSeriesData do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
