# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.TimeSeriesDescriptor do
  @moduledoc """
  A descriptor for the labels and points in a time series.

  ## Attributes

  *   `labelDescriptors` (*type:* `list(GoogleApi.Monitoring.V3.Model.LabelDescriptor.t)`, *default:* `nil`) - Descriptors for the labels.
  *   `pointDescriptors` (*type:* `list(GoogleApi.Monitoring.V3.Model.ValueDescriptor.t)`, *default:* `nil`) - Descriptors for the point data value columns.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :labelDescriptors => list(GoogleApi.Monitoring.V3.Model.LabelDescriptor.t()) | nil,
          :pointDescriptors => list(GoogleApi.Monitoring.V3.Model.ValueDescriptor.t()) | nil
        }

  field(:labelDescriptors, as: GoogleApi.Monitoring.V3.Model.LabelDescriptor, type: :list)
  field(:pointDescriptors, as: GoogleApi.Monitoring.V3.Model.ValueDescriptor, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.TimeSeriesDescriptor do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.TimeSeriesDescriptor.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.TimeSeriesDescriptor do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
