# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Monitoring.V3.Model.ValueDescriptor do
  @moduledoc """
  A descriptor for the value columns in a data point.

  ## Attributes

  *   `key` (*type:* `String.t`, *default:* `nil`) - The value key.
  *   `metricKind` (*type:* `String.t`, *default:* `nil`) - The value stream kind.
  *   `unit` (*type:* `String.t`, *default:* `nil`) - The unit in which time_series point values are reported. unit follows the UCUM format for units as seen in https://unitsofmeasure.org/ucum.html. unit is only valid if value_type is INTEGER, DOUBLE, DISTRIBUTION.
  *   `valueType` (*type:* `String.t`, *default:* `nil`) - The value type.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :key => String.t() | nil,
          :metricKind => String.t() | nil,
          :unit => String.t() | nil,
          :valueType => String.t() | nil
        }

  field(:key)
  field(:metricKind)
  field(:unit)
  field(:valueType)
end

defimpl Poison.Decoder, for: GoogleApi.Monitoring.V3.Model.ValueDescriptor do
  def decode(value, options) do
    GoogleApi.Monitoring.V3.Model.ValueDescriptor.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Monitoring.V3.Model.ValueDescriptor do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
